﻿@page "/user"
@using VacationSchedule.Core.Models.DB;
@inject HttpClient Http

<PageTitle>Сотрудники</PageTitle>

<h1>Сотрудники</h1>

@if (users == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <table class="table">
        <thead>
            <tr>
                <th>Ф.И.О</th>
                <th>Департамент</th>
                <th>Должность</th>
                <th>Действия</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var user in users)
            {
                <tr>
                    <td>@user.LastName @user.FirstName @user.PatronymicName</td>
                    <td>
                        <select class="form-control selectpicker" @bind="@user.DepartmentId">
                            <option>--select--</option>
                            @foreach (var item in departments)
                            {
                                <option value="@item.Id">@item.DepartmentName</option>
                            }
                        </select>
                    </td>
                    <td>
                        <input type="text" class="form-control" placeholder="Должность" @bind="@user.Position"/>
                    </td>
                    <td>
                        <button class="btn btn-primary" @onclick="@(e => SaveUser(@user))">Save</button>
                    </td>
                </tr>
            }
        </tbody>
    </table>
}

@code {
    private User[] users;
    private Department[] departments;

    protected override async Task OnInitializedAsync()
    {
        await RefreshData();
    }

    private async Task SaveUser(User user)
    {
        await Http.PutAsJsonAsync<User>($"api/User/{user.Id}", user);
        await RefreshData();
    }

    private async Task RefreshData()
    {
        users = await Http.GetFromJsonAsync<User[]>($"api/User");
        departments = await Http.GetFromJsonAsync<Department[]>($"api/Department");
    }
}
